
local StoneGateV6 = ...


-- Apply building asset processor
StoneGateV6:registerAssetProcessor("models/blueRoofs/blueMachicolationKeepPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/blueRoofs/blueMachicolationMainPlatform.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/blueRoofs/blueMachicolationSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/blueRoofs/blueMachicolationSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/blueRoofs/blueMachicolationOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerMachicolationPart(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV6:registerAssetId("models/blueRoofs/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    StoneGateV6:registerPrefabComponent("models/blueRoofs/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = _buildingZone
    })
end


function registerMachicolationPartMajor(_nameSize, _nameFbx, _nameAsset, _buildingZone)
    StoneGateV6:registerAssetId("models/blueRoofs/" .. _nameSize .. ".fbx/Prefab/machicolation/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set machicolation platform part
    StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })
end

registerMachicolationPart( "blueMachicolationKeepPlatform", "step_6_Keep_MachicolationRoofC", "MACHICOLATION_KEEP_BLUE_ROOF_C", { 0, 0 } )
registerMachicolationPart( "blueMachicolationMainPlatform", "step_6_Main_MachicolationRoofD", "MACHICOLATION_MAIN_BLUE_ROOF_D", { 0, 0 } )
registerMachicolationPartMajor( "blueMachicolationSmallSquaredTower", "step_6_Sst_RoofMA", "MACHICOLATION_SST_BLUE_ROOF_A", { 0, 0 } )
registerMachicolationPartMajor( "blueMachicolationSmallSquaredTower", "step_6_Sst_RoofMB", "MACHICOLATION_SST_BLUE_ROOF_B", { 0, 0 } )
registerMachicolationPart( "blueMachicolationSmallGate","step_4_SGate_StoneRoofA", "SGATE_MACHICOLATION_STONE_BLUE_ROOF_A", { 0, 0 } )
registerMachicolationPart( "blueMachicolationOctogonalTower","step_6_Octogonal_MachicolationRoof", "OTOWER_MACHICOLATION_BLUE_ROOF", { 0, 0 } )
